Bug 1844308 - Review Request: python-uvicorn - The lightning-fast ASGI server
Summary: Review Request: python-uvicorn - The lightning-fast ASGI server
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Fabian Affolter
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1668058 1798863 1844303
Blocks: 1793129
TreeView+ depends on / blocked
 
Reported: 2020-06-05 03:43 UTC by Carl George 🤠
Modified: 2020-08-18 20:13 UTC (History)
3 users (show)

Fixed In Version: python-uvicorn-0.11.8-1.fc34
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-08-18 20:13:19 UTC
Type: ---
mail: fedora-review+


Attachments (Terms of Use)

Description Carl George 🤠 2020-06-05 03:43:18 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/carlwgeorge/reviews/fedora-rawhide-x86_64/01426991-python-uvicorn/python-uvicorn.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/carlwgeorge/reviews/fedora-rawhide-x86_64/01426991-python-uvicorn/python-uvicorn-0.11.5-1.fc33.src.rpm

Description:
Uvicorn is a lightning-fast ASGI server implementation, using uvloop and
httptools.  Until recently Python has lacked a minimal low-level
server/application interface for asyncio frameworks.  The ASGI specification
fills this gap, and means we are now able to start building a common set of
tooling usable across all asyncio frameworks.  Uvicorn currently supports
HTTP/1.1 and WebSockets.  Support for HTTP/2 is planned.

Fedora Account System Username: carlwgeorge

One of this package's build requirements is python-watchgod, so please review bug 1844303 first.

Comment 1 Fabian Affolter 2020-06-07 07:33:07 UTC
Requires additionally a later httptools [1] and uvloop [2] release.

DEBUG util.py:621:   Problem: conflicting requests
DEBUG util.py:621:    - nothing provides (python3.9dist(httptools) >= 0.1 with python3.9dist(httptools) < 0.2) needed by python3-uvicorn-0.11.5-1.fc33.noarch
DEBUG util.py:621:    - nothing provides python3.9dist(uvloop) >= 0.14 needed by python3-uvicorn-0.11.5-1.fc33.noarch
DEBUG util.py:623:  (try to add '--skip-broken' to skip uninstallable packages or '--nobest' to use not only best candidate packages)


[1] https://github.com/encode/uvicorn/blob/master/setup.py#L47
[2] https://github.com/encode/uvicorn/blob/master/setup.py#L48

Comment 2 Carl George 🤠 2020-06-09 20:47:08 UTC
Thanks for catching that.  I'll see if I can help get those packages updated.

Comment 3 Itamar Reis Peixoto 2020-06-19 22:46:40 UTC
(In reply to Fabian Affolter from comment #1)
> Requires additionally a later httptools [1] and uvloop [2] release.

can you send a pull request to python-httptools ?

Comment 4 Itamar Reis Peixoto 2020-06-22 04:41:58 UTC
I have the patches required to upgrade the dependencies, if you would like to test before I submit the pull requests here are.

https://copr.fedorainfracloud.org/coprs/itamarjp/uvicorn/builds/

Comment 5 Carl George 🤠 2020-06-25 22:12:43 UTC
Thanks Itamar, I'll take a look.

Comment 6 Itamar Reis Peixoto 2020-07-12 23:41:30 UTC
I think you can continue this review now

Comment 7 Carl George 🤠 2020-07-13 14:44:56 UTC
In a rawhide container, I can install python3-uvicorn and run the example application from the GitHub readme.

Comment 8 Fabian Affolter 2020-08-18 16:09:17 UTC
- The latest upstream release is 0.11.8

Package APPROVED

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package must not depend on deprecated() packages.
  Note: python3-pytest4 is deprecated, you must not depend on it.
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/deprecating-packages/


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-clause "New" or "Revised"
     License". 74 files have unknown license. Detailed output of
     licensecheck in /home/fab/Documents/repos/reviews/1844308-python-
     uvicorn/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-uvicorn-0.11.5-1.fc34.noarch.rpm
          python-uvicorn-0.11.5-1.fc34.src.rpm
python3-uvicorn.noarch: W: spelling-error %description -l en_US uvloop -> loop
python3-uvicorn.noarch: W: spelling-error %description -l en_US httptools -> toadstools
python3-uvicorn.noarch: W: spelling-error %description -l en_US asyncio -> syncopation
python3-uvicorn.noarch: W: no-manual-page-for-binary uvicorn
python-uvicorn.src: W: spelling-error %description -l en_US uvloop -> loop
python-uvicorn.src: W: spelling-error %description -l en_US httptools -> toadstools
python-uvicorn.src: W: spelling-error %description -l en_US asyncio -> syncopation
2 packages and 0 specfiles checked; 0 errors, 7 warnings.




Rpmlint (installed packages)
----------------------------
warning: Found bdb Packages database while attempting sqlite backend: using bdb backend.
warning: Found bdb Packages database while attempting sqlite backend: using bdb backend.
python3-uvicorn.noarch: W: spelling-error %description -l en_US uvloop -> loop
python3-uvicorn.noarch: W: spelling-error %description -l en_US httptools -> toadstools
python3-uvicorn.noarch: W: spelling-error %description -l en_US asyncio -> syncopation
python3-uvicorn.noarch: W: invalid-url URL: https://www.uvicorn.org <urlopen error [Errno -3] Temporary failure in name resolution>
python3-uvicorn.noarch: W: no-manual-page-for-binary uvicorn
1 packages and 0 specfiles checked; 0 errors, 5 warnings.



Source checksums
----------------
https://github.com/encode/uvicorn/archive/0.11.5/uvicorn-0.11.5.tar.gz :
  CHECKSUM(SHA256) this package     : be40828a1cdabbc9fccf90b2d846f866f2c5e846e3ef7f75101cb3c76e9fc2df
  CHECKSUM(SHA256) upstream package : be40828a1cdabbc9fccf90b2d846f866f2c5e846e3ef7f75101cb3c76e9fc2df


Requires
--------
python3-uvicorn (rpmlib, GLIBC filtered):
    (python3.9dist(click) >= 7 with python3.9dist(click) < 8)
    (python3.9dist(h11) < 0.10 with python3.9dist(h11) >= 0.8)
    (python3.9dist(httptools) >= 0.1 with python3.9dist(httptools) < 0.2)
    (python3.9dist(websockets) >= 8 with python3.9dist(websockets) < 9)
    /usr/bin/python3
    python(abi)
    python3.9dist(setuptools)
    python3.9dist(uvloop)



Provides
--------
python3-uvicorn:
    python-uvicorn
    python3-uvicorn
    python3.9-uvicorn
    python3.9dist(uvicorn)
    python3dist(uvicorn)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review -b 1844308
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: R, Java, C/C++, Perl, fonts, Ocaml, SugarActivity, Haskell, PHP
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 9 Carl George 🤠 2020-08-18 16:49:53 UTC
> - The latest upstream release is 0.11.8

Update to the latest version, here it is if you'd like to take one last look.  The only change from the last spec file is the version number and changelog entry.

Spec URL: https://download.copr.fedorainfracloud.org/results/carlwgeorge/reviews/fedora-rawhide-x86_64/01616224-python-uvicorn/python-uvicorn.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/carlwgeorge/reviews/fedora-rawhide-x86_64/01616224-python-uvicorn/python-uvicorn-0.11.8-1.fc34.src.rpm

> - Package must not depend on deprecated() packages.
>   Note: python3-pytest4 is deprecated, you must not depend on it.
>   See: https://docs.fedoraproject.org/en-US/packaging-
>   guidelines/deprecating-packages/

I'm not sure where this is coming from.  The package has a build requirement of pytest, not pytest4, and the latest build pulled in python3-pytest-6.0.1-1.fc33 with passing tests.  Maybe this was a mixup around the time of the pytest4  package being introduced.

Comment 10 Gwyn Ciesla 2020-08-18 17:15:35 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-uvicorn


Note You need to log in before you can comment on or make changes to this bug.